/* Name: txasm.S
 * Project: Remote Sensor; transmitter
 * Author: Christian Starkjohann
 * Creation Date: 2005-03-20
 * Tabsize: 4
 * Copyright: (c) 2005 by OBJECTIVE DEVELOPMENT Software GmbH
 * License: Proprietary, free under certain conditions. See Documentation.
 * This Revision: $Id: txasm.S 96 2006-01-26 18:38:35Z cs $
 */

/* configs for io.h */
#define __SFR_OFFSET 0
#define _VECTOR(N) __vector_ ## N   /* io.h does not define this for asm */

#include <avr/io.h> /* for CPU I/O register definitions and vectors */
#include "hardware.h"

#define nop2    rjmp .+0

.text

; extern unsigned crc16(unsigned char *data, unsigned char len);
; CRC with polynomial from USB spec, returns inverted CRC.
; data: r24/25
; len: r22
; temp variables:
;   r18: data byte
;   r19: bit counter
;   r20/21: polynomial
;   r23: scratch
;   r24/25: crc-sum
;   r26/27=X: ptr
.global crc16
crc16:
    mov     XL, r24
    mov     XH, r25
    ldi     r24, 0xff
    ldi     r25, 0xff
    ldi     r20, lo8(0xa001)
    ldi     r21, hi8(0xa001)
crcByteLoop:
    subi    r22, 1
    brcs    crcReady
    ld      r18, x+
    ldi     r19, 8
crcBitLoop:
    mov     r23, r18
    eor     r23, r24
    lsr     r25
    ror     r24
    lsr     r18
    sbrs    r23, 0
    rjmp    crcNoXor
    eor     r24, r20
    eor     r25, r21
crcNoXor:
    dec     r19
    brne    crcBitLoop
    rjmp    crcByteLoop
crcReady:
    com     r24
    com     r25
    ret

; ----------------------------------------------------------------------------

