/* cm@tahina.priv.at 20070303

sniff the sensirion SHTxx protocol on the wire

required #DEFINEs: 
SCK_PORT
SCK_BIT
DATA_PORT
DATA_BIT

the ports have to be configured as inputs without pullups

*/


#define SCK_IS_LOW (!(SCK_PORT & (1<<SCK_BIT)))
#define SCK_IS_HIGH (SCK_PORT & (1<<SCK_BIT))
#define DATA_IS_LOW (!(DATA_PORT & (1<<DATA_BIT)))
#define DATA_IS_HIGH (DATA_PORT & (1<<DATA_BIT))

void sht_await_start(void) {

  while(!(SCK_IS_HIGH && DATA_IS_HIGH)) {};
  while(!(SCK_IS_HIGH && DATA_IS_LOW )) {};
  while(!(SCK_IS_LOW  && DATA_IS_LOW )) {};
  while(!(SCK_IS_HIGH && DATA_IS_LOW )) {};
  while(!(SCK_IS_HIGH && DATA_IS_HIGH)) {};
  while(SCK_IS_HIGH) {};
}

uint8_t sht_await_command(void) {
  uint8_t i, cmd;

  for(i = 0; i < 8; i++) {
    while(SCK_LOW) {};
    cmd &= DATA_IS_HIGH ? 1 : 0;
    cmd <<= 1;
    while(SCK_HIGH) {};
  }
  return cmd;
}

uint8_t sht_read_command(void) {
  sht_await_start();
  return sht_await_command();
}
